# -*- coding: utf-8 -*-
# gdh-win10.py
# author: Gerd Doeben-Henisch
# Trying a first environment
# Using book from John Zelle (2002) and his simple graphics.py library

def main():
   import graphics as grph        #Graphics onbjects from Zelle
   import environment as env      #Functions to generate grids
   import numpy as np             #numerical laibrary numpy
   import acctor as acc           #Acctor related functions
   
   ##
   ## SET UP THE ENVIRONMENT
   ##
   
   e1=env.ENVOBJ('env1',0)
   
   xmax = 700
   ymax = 700
   
   win = grph.GraphWin('ENVIRONMENT 1', xmax, ymax)
   win.setBackground('HoneyDew')
   

   first = 1    #First element of the list
   last = 7     # Last element of the list used
   distance = 100   #distance of two lines in thr grid
   maxXcoord = 7  #size of the data array in the background
   maxYcoord = 7
   nobj = 20    #objects: percentage of the array space !
   nfood = 1    #food: percentage of the array space !
   
   #generating the lines of the grid
   
   env.grid(win,xmax, ymax, first, last, distance)
   
  # Fill the grid with spaces and objects
   gr2=env.fillgridobj2(win,first, last, maxXcoord,maxYcoord,nobj)
   
   # Fill the grid with food
   gr2=env.fillgridfood(win,first, last, maxXcoord,maxYcoord,nfood,gr2)
   
   # Introducing an actor for the event-loop
   
   time=e1.getClock()  #Setting the time of 'birth'
   a=input("Please an x-coordinate (1-7) for the actor ")
   b=input("Please an y-coordinate (1-7) for the actor ")
   x=int(a)
   y=int(b)
   dir=1
   color = 'red'
   label="A1"
   energy=2000
   energyrate=2
   
   a1=acc.ACTOBJ(label,time,x,y,dir,color, label,energy,energyrate)

   a1.setPos(x,y)
   outputMessage='noMove'  #This will allow a move without interaction with
                           # the actor
   a1.setOutputMessage(outputMessage)
   
   env.introduceActor(x,y,dir,label,energy,distance,win)
   
   ##
   ## START AN EVENT LOOP FOR THE ENVIRONMENT
   ##
   ## ASK ACTOR BEHAVIOR FUNCTIONS WHAT TO DO
   ## CHECK WETHER ACTIONS ARE POSSIBLE
   ## MODIFY THE ENVIRONMENTR IF NECESSARY
   ## REPEAT AS LONG AS ACTORS ARE ALIVE
   ##
   
   # condition for while
   
   FINISH=100

   while FINISH >0:

    # Look to the actor class for new responses
    
    dir=a1.getDir()
    print('Direction = ', dir)
    p=a1.getPos()
    print('Actual Position = ',p)
    xold=p[0]
    yold=p[1]
    
    if a1.getOutputMessage() == 'yesMove':
    
    # If there are responses then compute the next possible move
    
        Err, xnew, ynew = env.newPosition(dir,xold,yold)
        print('Err = ', Err)
        print('New Position planned = ', (xnew,ynew))
    
        #Check whether this new position  is possible
    
        if gr2[xnew-1,ynew-1] != 0:
            #Telling the actor that the planned new position is occupied
            a1.setInputMessage("NoMove")
            print('actor =',label,' has not moved')
        else:
            type=3 #actor
            #First change position in data array
            env.moveArray(type,xold,yold,xnew,ynew,gr2)
            #Tell the actor his new position
            a1.setPos(xnew,ynew)
            #Next change position in window
            env.introduceActor(xnew,ynew,dir,label,energy,distance,win)
            env.deleteActor(p,win)
    else:
        print('No move wanted by actor.')
        
    # Get the actual environment time
    
    t2=e1.getClock()
    print('Environment Time =', t2)

    #Call the actor
    
    acc.behaviorAc(e1,a1)
 
    
    # The actor will compute i t's response and will update the class
   
    #counting FINISH down for to stop after finitely many steps
    FINISH=FINISH-1
    
    envClock = e1.getClock()
    print('Actual Environment Time = ',envClock)
    envClock= envClock+1
    e1.setClock(envClock)
    print('New  Environment Time = ',envClock)
    
    energy=a1.getEnergy()
    if energy <0:
        print('ATTENTION: Actor ',label,' has no more Energy!!!')
    
    answer = input("Next Step Wanted (y/n)")
    if answer == 'y':
        FINISH = FINISH  #Repeat the Loop
        
    
    else:
        FINISH = -1    #Finish
    
   answer = input("You want to close the window? (y/n)")
    

   win.close()
main()
